SUBSII ;
 	ORG	0000
 ;
 ; START ROUTINE #0 -- GET ADDRESS AND JUMP
 	CALL	0A7FH		; GET ROUTINE ADDRESS
 	PUSH	HL		; READY TO ZIP BACK
 	RET			; AND EXECUTE ADDRESS
 ;
 ; SCREEN WHITE-OUT ... ROUTINE #0A
 	LD	HL,3C00H
 	LD	DE,3C01H
 	LD	BC,03FFH
 	LD	(HL),0BFH
 	LDIR
 	RET
 ;
 ; SCREEN REVERSE ... ROUTINE #0B
 	LD	HL,3C00H
 LOOP1	LD	A,(HL)
 	CPL
 	LD	(HL),A
 	INC	HL
 	LD	A,H
 	CP	40H
 	JR	NZ,LOOP1
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; SOUND OUTPUT ... ROUTINE #1
 	CALL	0A7FH
 	PUSH	HL
 	LD	DE,0180H
 	EX	DE,HL
 	SBC	HL,DE
 	EX	DE,HL
 LOOP2	POP	BC
 	PUSH	BC
 	LD	A,(403DH)
 	OR	2
 	OUT	(0FFH),A
 DELAY1	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,DELAY1
 	POP	BC
 	PUSH	BC
 	LD	A,(403DH)
 	OUT	(0FFH),A
 DELAY2	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,LOOP2
 	DEC	DE
 	LD	A,D
 	OR	E
 	JR	NZ,LOOP2
 	POP	HL
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; VOICE OUTPUT ... ROUTINE #2
 	CALL	0A7FH
 	LD	DE,0400H
 	PUSH	DE
 	LD	A,(403DH)
 	LD	C,A
 LOOP4	LD	D,8
 	LD	A,(HL)
 	LD	E,A
 	XOR	A
 LOOP5	RL	E
 	RL	A
 	OR	C
 	OUT	(0FFH),A
 	LD	B,6
 DELAY3	DJNZ	DELAY3
 	XOR	A
 	DEC	D
 	JR	NZ,LOOP5
 	INC	HL
 	POP	DE
 	DEC	DE
 	PUSH	DE
 	LD	A,D
 	OR	E
 	JR	NZ,LOOP4
 	POP	DE
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; START ROUTINE #3 -- GET START ADDRESS AND JUMP
 	CALL	0A7FH
 	PUSH	HL
 	RET
 ;
 ; UPWARD SCROLL ... ROUTINE #3A
 	LD	HL,3C40H
 	LD	DE,3C00H
 	LD	BC,03C0H
 	LDIR
 	RET
 ;
 ; DOWNWARD SCROLL ... ROUTINE #3B
 	LD	HL,3FBFH
 	LD	DE,3FFFH
 	LD	BC,03BFH
 	LDDR
 	RET
 ;
 ; RIGHTWARD SCROLL ... ROUTINE #3C
 	LD	HL,3FFEH
 	LD	DE,3FFFH
 	LD	BC,03FFH
 	LDDR
 	INC	HL
 	LD	(HL),20H
 	RET
 ;
 ; LEFTWARD SCROLL ... ROUTINE #3D
 	LD	HL,3C01H
 	LD	DE,3C00H
 	LD	BC,03FFH
 	LDIR
 	DEC	HL
 	LD	(HL),20H
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; START ROUTINE #4 -- GET START ADDRESS AND JUMP
 	CALL	0A7FH
 	PUSH	HL
 	RET
 ;
 ; RIGHT CLEAR ... ROUTINE #4A
 	LD	HL,3C3FH
 	LD	DE,0040H
 	LD	B,0FH
 LOOP6	LD	(HL),20H
 	ADD	HL,DE
 	DJNZ	LOOP6
 	RET
 ;
 ; LEFT CLEAR ... ROUTINE #4B
 	LD	HL,3C00H
 	LD	DE,0040H
 	LD	B,0FH
 LOOP7	LD	(HL),20H
 	ADD	HL,DE
 	DJNZ	LOOP7
 	RET
 ;
 ; TOP CLEAR ... ROUTINE #4C
 	LD	HL,3C00H
 	LD	DE,3C01H
 	LD	BC,003FH
 	LD	(HL),20H
 	LDIR
 	RET
 ;
 ; BOTTOM CLEAR ... ROUTINE #4D
 	LD	HL,3FC0H
 	LD	DE,3FC1H
 	LD	BC,003FH
 	LD	(HL),20H
 	LDIR
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; LOAD TOP SCREEN FROM MEMORY ... ROUTINE #5A/VERS.1
 	CALL	0A7FH		; GET MAP POSITION
 	LD	DE,3C00H	; CHANGE 3C00/3F80
 	LD	B,0		; ALWAYS ZERO
 	LD	A,(0FC01H)	; VARIABLE HL (HOR CHARS)
 	OR	A		; TEST FOR ZERO
 	RET	Z		; BACK IF NO LOAD
 	LD	C,A		; XFER TO LOW BYTE
 	LDIR			; DRAW
 	RET
 ;
 ; LOAD TOP SCREEN FROM MEMORY ... ROUTINE #5B/VERS.1
 	CALL	0A7FH		; GET MAP POSITION
 	LD	DE,3C00H	; CHANGE 3C00/3F80
 	LD	A,(0FC01H)	; VARIABLE HL (HOR CHARS)
 	ADD	A,E		; TOTAL ROW + HOR CHARS
 	LD	E,A		; MAKE NEW LOW BYTE
 	LD	B,0		; ALWAYS ZERO
 	LD	A,(0FC02H)	; VARIABLE HR (HOR REMDR)
 	OR	A		; TEST FOR VALUE
 	RET	Z		; RETURN IF NO LOAD
 	LD	C,A		; XFER TO LOW BYTE
 	LDIR			; DRAW
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; LOAD BOTTOM SCREEN FROM MEMORY ... ROUTINE #5A/VERS.2
 	CALL	0A7FH		; GET MAP POSITION
 	LD	DE,3F80H	; CHANGE 3F80/3C00
 	LD	B,0		; ALWAYS ZERO
 	LD	A,(0FC01H)	; VARIABLE HL (HOR CHARS)
 	OR	A		; TEST VALUE
 	RET	Z		; RETURN IF NO LOAD
 	LD	C,A		; XFER TO LOW BYTE
 	LDIR			; DRAW
 	RET
 ;
 ; LOAD BOTTOM SCREEN FROM MEMORY ... ROUTINE #5B/VERS.2
 	CALL	0A7FH		; GET MAP POSITION
 	LD	DE,3F80H	; CHANGE 3F80/3C00
 	LD	A,(0FC01H)	; VARIABLE HL (HOR CHARS)
 	ADD	A,E		; TOTAL ROW + HORIZ
 	LD	E,A		; MAKE NEW LOW BYTE
 	LD	B,0		; ALWAYS ZERO
 	LD	A,(0FC02H)	; VARIABLE HR (HOR REMDR)
 	OR	A		; TEST VALUE
 	RET	Z		; RETURN IF NO LOAD
 	LD	C,A		; XFER TO LOW BYTE
 	LDIR			; DRAW
 	RET
 ;
 	ORG	0000
 ;
 ; LOAD LEFT SCREEN FROM MEMORY ... ROUTINE #6A/VERS.1
 	CALL	0A7FH		; GET MAP POSITION
 	LD	IX,3C00H	; CHANGE 3C00/3C3F
 	LD	DE,0040H	; ONE-LINE OFFSET
 	LD	A,(0FC03H)	; VARIABLE VT (VERT CHRS)
 	OR	A		; TEST VALUE
 	RET	Z		; RETURN IF NO LOAD
 	LD	B,A		; GIVE TO COUNTER
 LOOP8	LD	A,(HL)		; GET CHAR FROM MAP
 	LD	(IX),A		; PUT TO SCREEN
 	ADD	HL,DE		; ADVANCE MAP POSITION
 	ADD	IX,DE		; ADVANCE SCREEN POS'N
 	DJNZ	LOOP8		; DRAW
 	RET
 ;
 ; LOAD LEFT SCREEN FROM MEMORY ... ROUTINE #6B/VERS.1
 	CALL	0A7FH		; GET MAP POSITION
 	LD	IX,3C00H	; CHANGE 3C00/3C3F
 	LD	DE,0040H	; ONE-LINE OFFSET
 	LD	A,(0FC03H)	; VARIABLE VT (VERT CHRS)
 	OR	A		; TEST VALUE
 	JR	Z,JUMPX		; GO IF NO OFFSET
 	LD	B,A		; GIVE TO COUNTER
 LOOP9	ADD	IX,DE		; MOVE SCREEN POSITION
 	DJNZ	LOOP9		; LOOP
 JUMPX	LD	A,(0FC04H)	; VARIABLE VB (VERT RMDR)
 	OR	A		; TEST VALUE
 	RET	Z		; RETURN IF NO LOAD
 	LD	B,A		; RESTORE COUNTER
 LOOP10	LD	A,(HL)		; GET CHAR FROM MAP
 	LD	(IX),A		; PUT TO SCREEN
 	ADD	HL,DE		; ADVANCE MAP POSITION
 	ADD	IX,DE		; ADVANCE SCREEN POS'N
 	DJNZ	LOOP10		; DRAW
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; LOAD RIGHT SCREEN FROM MEMORY ... ROUTINE #6A/VERS.2
 	CALL	0A7FH		; GET MAP POSITION
 	LD	IX,3C3FH	; CHANGE 3C3F/3C00
 	LD	DE,0040H	; ONE-LINE OFFSET
 	LD	A,(0FC03H)	; VARIABLE VT (VERT CHRS)
 	OR	A		; TEST VALUE
 	RET	Z		; RETURN IF NO LOAD
 	LD	B,A		; GIVE TO COUNTER
 LOOP11	LD	A,(HL)		; GET CHAR FROM MAP
 	LD	(IX),A		; PUT TO SCREEN
 	ADD	HL,DE		; ADVANCE MAP POSITION
 	ADD	IX,DE		; ADVANCE SCREEN POS'N
 	DJNZ	LOOP11		; DRAW
 	RET
 ;
 ; LOAD RIGHT SCREEN FROM MEMORY ... ROUTINE #6B/VERS.2
 	CALL	0A7FH		; GET MAP POSITION
 	LD	IX,3C3FH	; CHANGE 3C3F/3C00
 	LD	DE,0040H	; ONE-LINE OFFSET
 	LD	A,(0FC03H)	; VARIABLE VT (VERT CHRS)
 	OR	A		; TEST VALUE
 	JR	Z,JUMPY		; GO IF NO OFFSET
 	LD	B,A		; GIVE TO COUNTER
 LOOP12	ADD	IX,DE		; MOVE SCREEN POS'N
 	DJNZ	LOOP12		; LOOP
 JUMPY	LD	A,(0FC04H)	; VARIABLE VB (VERT RMDR)
 	OR	A		; TEST VALUE
 	RET	Z		; RETURN IF NO LOAD
 	LD	B,A		; RESTORE COUNTER
 LOOP13	LD	A,(HL)		; GET CHAR FROM MAP
 	LD	(IX),A		; PUT TO SCREEN
 	ADD	HL,DE		; ADVANCE MAP POSITION
 	ADD	IX,DE		; ADVANCE SCREEN POS'N
 	DJNZ	LOOP13		; DRAW
 	RET
 ;
 	END
